Build your web apps using Smart UI
Smart.Grid - Get Specific Row and Cell Index
Get Specific Row and Cell Index
Smart.Grid allows getting and manipulating its rows and cells directly.
Getting Grid Rows
To get a collection of all Grid rows, access the rows property. And here is how to get a row at a specific index:
const grid = <Grid>document.getElementById('grid');
const thirdRow = grid.rows![2];
The row object presents a large number of fields with specific information about the row:
- element - the repective smart-grid-row HTML element; this property returns null when the row is not in the view.
- data - the data visualized in the row.
- index - the row's index.
- visibleIndex - the row's visible index.
- id - the row's id.
- height - the height of the row.
- minHeight - the row's min height.
- maxHeight - the row's max height.
- cellHeight - the height of the row's cells.
- showDetail - whether the row details are shown.
- detailHeight - the height of the row details.
- detailTemplate - sets or gets the row's detail template.
- checked - whether the row is checked.
- enabled - whether the row is enabled.
- expanded - whether the row is expanded (in tree grid mode).
- filtered - whether the row is filtered.
- freeze - whether the row is frozen (pinned).
- selected - whether the row is selected.
- visible - whether the row is visible. Set the property to false to hide the row.
- allowCheck - whether the row can be checked.
- allowResize - whether the row can be resized.
- allowSelect - whether the row can be selected.
- allowToggle - whether the row can be toggled (in tree grid mode).
- header - gets the row's header element.
- leaf - whether the row is a "leaf" (has no descendants in tree grid mode).
- parent - the parent row (group row or parent row in tree grid mode)
- parentId - the parent row's id.
- children - an array of the row's children (when either grouping or tree grid mode is enabled).
- level - the row's level of nesting (when the Grid is grouped).
Getting Grid Cells
In addition to the aforementioned row properties, the row object provides a cells collection of all cells in the respective row. The following code shows how to get a specific cell object:
const grid =document.getElementById('grid'); const thirdRow = grid.rows![2]; const cellInSecondColumn = thirdRow.cells![1];
The cell object also presents several fields with useful information about the cell:
- element- the repective smart-grid-cell HTML element.
- value - the cell's value; can be used for setting or getting the value.
- oldValue - the cell's old value (if applicable).
- row - the object of the row the cell is in.
- column - the object of the column the cell is in.
- focused - whether the cell is focused.
- isEditing - whether the cells is currently being edited.
- readonly - whether the cell is readonly (cannot be edited).
- selected - whether the cell is selected.
- editor - sets or gets the cell's editor.
- template - the cell's template.
- tooltip - the cell's tooltip.
- rowSpan - the number of rows the cell spans (1 by default, if the cell is no part of merged cells).
- colSpan - the number of columns the cell spans (1 by default, if the cell is no part of merged cells).
- align - sets or gets the horizontal alignment of the cell.
- color - sets or gets the cell's text color.
- background - sets or gets the cell's background.
- borderColor - sets or gets the cell's borderColor.
- fontFamily - sets or gets the cell's fontFamily.
- fontSize - sets or gets the cell's fontSize.
- fontStyle - sets or gets the cell's fontStyle.
- fontWeight - sets or gets the cell's fontWeight.
- verticalAlign - sets or gets the vertical alignment.
- getFormattedValue - gets a formatted number or Date.
- setProperties - a function that allows you to update multiple properties with single refresh.
For AI tooling
Developer Quick Reference
Topic: grid-row-cell-index Component: Grid Framework: JavaScript
Main methods: (none detected)
Common config keys: (none detected)
Implementation Notes
Compatibility: Modern browsers / Web Components API access pattern: const component = document.querySelector(...) + component.method()
Lifecycle guidance: Initialize configuration first, then invoke imperative API when element is available in DOM.
Common pitfalls:
- Calling methods before element initialization.
- Reassigning large configuration partially without understanding merge behavior.
- Missing required module script import for component type.
Validation checklist:
- Ensure module scripts and CSS are loaded once.
- Keep data schema aligned with columns/series definitions.
- Verify method calls target initialized component instance.

Get Specific Row and Cell Index

Grid for Angular

Angular standalone version of this topic (compatible with Angular 17+). Import both the Smart UI component and module in the standalone component.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { RouterOutlet } from '@angular/router';
import { GridComponent, GridModule } from 'smart-webcomponents-angular/grid';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [CommonModule, GridModule, RouterOutlet],
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css'],
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  @ViewChild('grid', { read: GridComponent, static: false }) grid!: GridComponent;
}
<!-- app.component.html -->
<smart-grid #grid></smart-grid>

Use this.grid for API methods in this topic.

Get Specific Row and Cell Index

Smart.Grid allows getting and manipulating its rows and cells directly.

Getting Grid Rows

To get a collection of all Grid rows, access the rows property. And here is how to get a row at a specific index:

const grid = <Grid>document.getElementById('grid');
const thirdRow = this.grid.rows![2];

The row object presents a large number of fields with specific information about the row:

  • element - the repective smart-grid-row HTML element; this property returns null when the row is not in the view.
  • data - the data visualized in the row.
  • index - the row's index.
  • visibleIndex - the row's visible index.
  • id - the row's id.
  • height - the height of the row.
  • minHeight - the row's min height.
  • maxHeight - the row's max height.
  • cellHeight - the height of the row's cells.
  • showDetail - whether the row details are shown.
  • detailHeight - the height of the row details.
  • detailTemplate - sets or gets the row's detail template.
  • checked - whether the row is checked.
  • enabled - whether the row is enabled.
  • expanded - whether the row is expanded (in tree grid mode).
  • filtered - whether the row is filtered.
  • freeze - whether the row is frozen (pinned).
  • selected - whether the row is selected.
  • visible - whether the row is visible. Set the property to false to hide the row.
  • allowCheck - whether the row can be checked.
  • allowResize - whether the row can be resized.
  • allowSelect - whether the row can be selected.
  • allowToggle - whether the row can be toggled (in tree grid mode).
  • header - gets the row's header element.
  • leaf - whether the row is a "leaf" (has no descendants in tree grid mode).
  • parent - the parent row (group row or parent row in tree grid mode)
  • parentId - the parent row's id.
  • children - an array of the row's children (when either grouping or tree grid mode is enabled).
  • level - the row's level of nesting (when the Grid is grouped).

Getting Grid Cells

In addition to the aforementioned row properties, the row object provides a cells collection of all cells in the respective row. The following code shows how to get a specific cell object:

const grid = document.getElementById('grid');
const thirdRow = this.grid.rows![2];
const cellInSecondColumn = thirdRow.cells![1];

The cell object also presents several fields with useful information about the cell:

  • element- the repective smart-grid-cell HTML element.
  • value - the cell's value; can be used for setting or getting the value.
  • oldValue - the cell's old value (if applicable).
  • row - the object of the row the cell is in.
  • column - the object of the column the cell is in.
  • focused - whether the cell is focused.
  • isEditing - whether the cells is currently being edited.
  • readonly - whether the cell is readonly (cannot be edited).
  • selected - whether the cell is selected.
  • editor - sets or gets the cell's editor.
  • template - the cell's template.
  • tooltip - the cell's tooltip.
  • rowSpan - the number of rows the cell spans (1 by default, if the cell is no part of merged cells).
  • colSpan - the number of columns the cell spans (1 by default, if the cell is no part of merged cells).
  • align - sets or gets the horizontal alignment of the cell.
  • color - sets or gets the cell's text color.
  • background - sets or gets the cell's background.
  • borderColor - sets or gets the cell's borderColor.
  • fontFamily - sets or gets the cell's fontFamily.
  • fontSize - sets or gets the cell's fontSize.
  • fontStyle - sets or gets the cell's fontStyle.
  • fontWeight - sets or gets the cell's fontWeight.
  • verticalAlign - sets or gets the vertical alignment.
  • getFormattedValue - gets a formatted number or Date.
  • setProperties - a function that allows you to update multiple properties with single refresh.
For AI tooling

Developer Quick Reference

Topic: grid-row-cell-index   Component: Grid   Framework: Angular

Main methods: (none detected)

Common config keys: (none detected)

Implementation Notes

Compatibility: Angular 17+ (standalone)   API access pattern: @ViewChild(...) + this.component.method()

Lifecycle guidance: Bind inputs declaratively and call imperative API through @ViewChild in/after ngAfterViewInit.

Common pitfalls:

  • Using @ViewChild API too early (before view init).
  • Omitting standalone imports for Smart modules in @Component.imports.
  • Type mismatches between configuration fields and template bindings.

Validation checklist:

  • Ensure module import exists in standalone component imports array.
  • Use typed @ViewChild(..., { read: ComponentType }).
  • Call imperative methods after view initialization.

Get Specific Row and Cell Index

Grid for Vue

Vue 3 version using Smart custom elements and template refs.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

<script setup>
import { onMounted, ref } from 'vue';
import 'smart-webcomponents/source/styles/smart.default.css';
import 'smart-webcomponents/source/modules/smart.grid.js';

const component = ref();
const componentProps = {
  // Copy this topic's JavaScript configuration here.
};

onMounted(() => {
  Object.assign(component.value, componentProps);
});
</script>

<template>
  <smart-grid ref="component"></smart-grid>
</template>

Use component.value for API methods in this topic.

Get Specific Row and Cell Index

Smart.Grid allows getting and manipulating its rows and cells directly.

Getting Grid Rows

To get a collection of all Grid rows, access the rows property. And here is how to get a row at a specific index:

const grid = <Grid>document.getElementById('grid');
const thirdRow = component.value.rows![2];

The row object presents a large number of fields with specific information about the row:

  • element - the repective smart-grid-row HTML element; this property returns null when the row is not in the view.
  • data - the data visualized in the row.
  • index - the row's index.
  • visibleIndex - the row's visible index.
  • id - the row's id.
  • height - the height of the row.
  • minHeight - the row's min height.
  • maxHeight - the row's max height.
  • cellHeight - the height of the row's cells.
  • showDetail - whether the row details are shown.
  • detailHeight - the height of the row details.
  • detailTemplate - sets or gets the row's detail template.
  • checked - whether the row is checked.
  • enabled - whether the row is enabled.
  • expanded - whether the row is expanded (in tree grid mode).
  • filtered - whether the row is filtered.
  • freeze - whether the row is frozen (pinned).
  • selected - whether the row is selected.
  • visible - whether the row is visible. Set the property to false to hide the row.
  • allowCheck - whether the row can be checked.
  • allowResize - whether the row can be resized.
  • allowSelect - whether the row can be selected.
  • allowToggle - whether the row can be toggled (in tree grid mode).
  • header - gets the row's header element.
  • leaf - whether the row is a "leaf" (has no descendants in tree grid mode).
  • parent - the parent row (group row or parent row in tree grid mode)
  • parentId - the parent row's id.
  • children - an array of the row's children (when either grouping or tree grid mode is enabled).
  • level - the row's level of nesting (when the Grid is grouped).

Getting Grid Cells

In addition to the aforementioned row properties, the row object provides a cells collection of all cells in the respective row. The following code shows how to get a specific cell object:

const grid = document.getElementById('grid');
const thirdRow = component.value.rows![2];
const cellInSecondColumn = thirdRow.cells![1];

The cell object also presents several fields with useful information about the cell:

  • element- the repective smart-grid-cell HTML element.
  • value - the cell's value; can be used for setting or getting the value.
  • oldValue - the cell's old value (if applicable).
  • row - the object of the row the cell is in.
  • column - the object of the column the cell is in.
  • focused - whether the cell is focused.
  • isEditing - whether the cells is currently being edited.
  • readonly - whether the cell is readonly (cannot be edited).
  • selected - whether the cell is selected.
  • editor - sets or gets the cell's editor.
  • template - the cell's template.
  • tooltip - the cell's tooltip.
  • rowSpan - the number of rows the cell spans (1 by default, if the cell is no part of merged cells).
  • colSpan - the number of columns the cell spans (1 by default, if the cell is no part of merged cells).
  • align - sets or gets the horizontal alignment of the cell.
  • color - sets or gets the cell's text color.
  • background - sets or gets the cell's background.
  • borderColor - sets or gets the cell's borderColor.
  • fontFamily - sets or gets the cell's fontFamily.
  • fontSize - sets or gets the cell's fontSize.
  • fontStyle - sets or gets the cell's fontStyle.
  • fontWeight - sets or gets the cell's fontWeight.
  • verticalAlign - sets or gets the vertical alignment.
  • getFormattedValue - gets a formatted number or Date.
  • setProperties - a function that allows you to update multiple properties with single refresh.
For AI tooling

Developer Quick Reference

Topic: grid-row-cell-index   Component: Grid   Framework: Vue

Main methods: (none detected)

Common config keys: (none detected)

Implementation Notes

Compatibility: Vue 3+   API access pattern: const component = ref() + component.value.method()

Lifecycle guidance: Use template refs with

Get Specific Row and Cell Index

Grid for React

React version of this topic (compatible with React 19+). Keep the same configuration logic from JavaScript and pass it as component props.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import React, { useMemo, useRef } from 'react';
import { Grid } from 'smart-webcomponents-react/grid';
import 'smart-webcomponents-react/source/styles/smart.default.css';

export default function App() {
  const componentRef = useRef(null);
  const componentProps = useMemo(() => ({
    // Copy this topic's JavaScript configuration here.
  }), []);

  return <Grid ref={componentRef} {...componentProps}></Grid>;
}

Use componentRef.current for API methods in this topic.

Get Specific Row and Cell Index

Smart.Grid allows getting and manipulating its rows and cells directly.

Getting Grid Rows

To get a collection of all Grid rows, access the rows property. And here is how to get a row at a specific index:

const grid = <Grid>document.getElementById('grid');
const thirdRow = componentRef.current.rows![2];

The row object presents a large number of fields with specific information about the row:

  • element - the repective smart-grid-row HTML element; this property returns null when the row is not in the view.
  • data - the data visualized in the row.
  • index - the row's index.
  • visibleIndex - the row's visible index.
  • id - the row's id.
  • height - the height of the row.
  • minHeight - the row's min height.
  • maxHeight - the row's max height.
  • cellHeight - the height of the row's cells.
  • showDetail - whether the row details are shown.
  • detailHeight - the height of the row details.
  • detailTemplate - sets or gets the row's detail template.
  • checked - whether the row is checked.
  • enabled - whether the row is enabled.
  • expanded - whether the row is expanded (in tree grid mode).
  • filtered - whether the row is filtered.
  • freeze - whether the row is frozen (pinned).
  • selected - whether the row is selected.
  • visible - whether the row is visible. Set the property to false to hide the row.
  • allowCheck - whether the row can be checked.
  • allowResize - whether the row can be resized.
  • allowSelect - whether the row can be selected.
  • allowToggle - whether the row can be toggled (in tree grid mode).
  • header - gets the row's header element.
  • leaf - whether the row is a "leaf" (has no descendants in tree grid mode).
  • parent - the parent row (group row or parent row in tree grid mode)
  • parentId - the parent row's id.
  • children - an array of the row's children (when either grouping or tree grid mode is enabled).
  • level - the row's level of nesting (when the Grid is grouped).

Getting Grid Cells

In addition to the aforementioned row properties, the row object provides a cells collection of all cells in the respective row. The following code shows how to get a specific cell object:

const grid = document.getElementById('grid');
const thirdRow = componentRef.current.rows![2];
const cellInSecondColumn = thirdRow.cells![1];

The cell object also presents several fields with useful information about the cell:

  • element- the repective smart-grid-cell HTML element.
  • value - the cell's value; can be used for setting or getting the value.
  • oldValue - the cell's old value (if applicable).
  • row - the object of the row the cell is in.
  • column - the object of the column the cell is in.
  • focused - whether the cell is focused.
  • isEditing - whether the cells is currently being edited.
  • readonly - whether the cell is readonly (cannot be edited).
  • selected - whether the cell is selected.
  • editor - sets or gets the cell's editor.
  • template - the cell's template.
  • tooltip - the cell's tooltip.
  • rowSpan - the number of rows the cell spans (1 by default, if the cell is no part of merged cells).
  • colSpan - the number of columns the cell spans (1 by default, if the cell is no part of merged cells).
  • align - sets or gets the horizontal alignment of the cell.
  • color - sets or gets the cell's text color.
  • background - sets or gets the cell's background.
  • borderColor - sets or gets the cell's borderColor.
  • fontFamily - sets or gets the cell's fontFamily.
  • fontSize - sets or gets the cell's fontSize.
  • fontStyle - sets or gets the cell's fontStyle.
  • fontWeight - sets or gets the cell's fontWeight.
  • verticalAlign - sets or gets the vertical alignment.
  • getFormattedValue - gets a formatted number or Date.
  • setProperties - a function that allows you to update multiple properties with single refresh.
For AI tooling

Developer Quick Reference

Topic: grid-row-cell-index   Component: Grid   Framework: React

Main methods: (none detected)

Common config keys: (none detected)

Implementation Notes

Compatibility: React 19+   API access pattern: const componentRef = useRef(null) + componentRef.current.method()

Lifecycle guidance: Use useMemo for large config objects and call imperative API through componentRef.current after first render.

Common pitfalls:

  • Recreating columns/dataSource objects on every render can reset component state.
  • Calling API methods before ref is available causes runtime errors.
  • Mixing controlled and imperative updates without sync can lead to stale UI.

Validation checklist:

  • Keep config objects memoized when possible.
  • Guard API calls with ref existence checks.
  • Verify CSS theme import is present once per app.